function love.load()
   pie = { 
   love.graphics.newImage("pie.png"),
   imgy = 100,
   imgx = 100,
   height = 128,
   width = 128,
   love.keyboard.setKeyRepeat(0.01, 0.01),
   dragging = { active = false, diffimgx = 0, diffimgy = 0 },
   }
end

function love.update(dt)
  if pie.dragging.active then
	pie.imgx = love.mouse.getimgx() - pie.dragging.diffimgx
    pie.imgy = love.mouse.getimgy() - pie.dragging.diffimgy
  end
end

function love.keypressed(key, unicode)
   if key == 'up' then
      imgy = imgy - 2
   elseif key == 'down' then
      imgy = imgy + 2
   elseif key == 'left' then
      imgx = imgx - 2
   elseif key == 'right' then
      imgx = imgx + 2
   end
end

function love.draw()
   love.graphics.draw(pie, imgx, imgy)
end

function love.mousepressed(imgx, imgy, button)
  if button == "l"
  and imgx > pie.imgx and imgx < pie.imgx + pie.width
  and imgy > pie.imgy and imgy < pie.imgy + pie.height
  then
    pie.dragging.active = true
    pie.dragging.diffimgx = imgx - pie.imgx
    pie.dragging.diffimgy = imgy - pie.imgy
  end
end

function love.mousereleased(imgx, imgy, button)
  if button == "l" then pie.dragging.active = false end
end